#pragma once

#include "map.h"

#define MOVE_DELAY 3
#define MAX_SPEED 1.0
#define XROTATE_SPEED 1.5
#define YROTATE_SPEED 3.0

typedef class c_editor : public c_map{

public:

	c_editor ();
	~c_editor ();

	int		lx, ly;
	float	x, y, z;		// View Coordinates
	float	cx, cy, cz;		// Camera Coordinates
	float	ws, ss;			// Move Speeds
	float	xa, ya;			// Angles
	float	xas, yas;		// Angle Change Speed
	float	camera;			// Camera Distance

	/**
		Manipulation Mode:
			0 - overview (cursor - view, pgup/dn - scale)
			1 - land (cursor - moving, space - toggle)
			2 - height (cursor - moving, pgup/dn - change height, home/end - max/min height) 
			3 - recources (cursor - moving, space - toggle, pgup/dn - up/down)
			4 - textures (cursor - moving, pgup/dn - change texture, home/end - rotate texture) 
	*/

	int		mode;
	int		rotmode;
	float	cmod;
	int		cmdr;

	void	process (void * vworld);
	void	render	(void * vworld);

private:

	float	wg2r	(float angle);

} c_editor_t, *c_editor_p;